import pytest

from jarvis_core import filters


@pytest.fixture()
def faker_locale():
    return ["en_US"]


def test_invites(faker):
    invites = ["discord.gg/asdf", "discord.com/invite/asdf", "discord://asdf/invite/asdf"]
    for invite in invites:
        assert filters.invites.match(invite)
    for _ in range(100):
        assert not filters.invites.match(faker.url())


def test_custom_emotes():
    emotes = ["<:test:000>", "<a:animated:000>"]
    not_emotes = ["<invalid:000>", "<:a:invalid:000>", "<invalid:000:>"]

    for emote in emotes:
        print(emote)
        assert filters.custom_emote.match(emote)
    for not_emote in not_emotes:
        assert not filters.custom_emote.match(not_emote)


def test_url(faker):
    for _ in range(100):
        assert filters.url.match(faker.url())


def test_email(faker):
    for _ in range(100):
        assert filters.email.match(faker.ascii_email())


def test_ipv4(faker):
    for _ in range(100):
        assert filters.ipv4.match(faker.ipv4())


def test_ipv4(faker):
    for _ in range(100):
        assert filters.ipv6.match(faker.ipv6())
